/*
 * MICONV.H -- LIBMI conventions
 *
 *     Copyright c 1995 Illustra Information Technologies, Inc.
 *     All rights reserved.      See files/copyright.
 *
 */

#ifndef	_MICONV_H_
#define	_MICONV_H_

/*
 *  New defines are MI_WINNT and MI_WIN31.
 *  We still support WIN32 and MI_WIN31_PORT.
 */

#ifdef WIN32
#ifndef MI_WINNT
#define MI_WINNT
#endif /* MI_WINNT */
#endif /* WIN32 */

#ifdef MI_WIN31
#ifndef MI_WIN31_PORT
#define MI_WIN31_PORT
#endif /*  MI_WIN31_PORT */
#endif /* MI_WIN31 */


/*
 *  Compiler-specific switches.
 */

#if defined(_MSC_VER) || defined(__TURBOC__) || defined(WIN32) || defined(_WINDOWS) || defined(_WINDLL)

#if !defined(MI_WINNT) && !defined(MI_WIN31)
#define MI_WIN31
#endif /* !WIN32 && !MI_WIN31_PORT */

#endif /* PC compilers */


#ifdef __STDC__

#if __STDC__ > 0
#ifndef MI_HAS_STDC
#define MI_HAS_STDC
#endif /* MI_HAS_STDC */
#endif /* __STDC__ > 0 */

#endif /* __STDC__ */

/*
 *  Microsoft compilers do not define __STDC__ if compiled with
 *  microsoft extensions.
 */

#if defined(MI_WINNT) || defined(MI_WIN31)

#ifndef MI_HAS_STDC
#define MI_HAS_STDC
#endif /* MI_HAS_STDC */

#endif /* pc compilers */


#if !defined(MI_HAS_STDC) && !defined(__cplusplus)
#define const
#define signed
#endif /* !defined(MI_HAS_STDC) && !defined(__cplusplus) */


#if defined(MI_HAS_STDC) || defined(__cplusplus)
#ifndef MI_NO_PROTOTYPES
#define MI_HAS_PROTOTYPES
#endif /* MI_NO_PROTOTYPES */
#endif /* defined(MI_HAS_STDC) || defined(__cplusplus) */

#ifndef ARGS
#ifdef MI_HAS_PROTOTYPES
#define	ARGS(x)	x
#else /* MI_HAS_PROTOTYPES */
#define ARGS(x)	()
#endif /* MI_HAS_PROTOTYPES */
#endif /* !ARGS */

#if defined(MI_HAS_STDC)
#ifndef MI_NO_STDARG
#define MI_USE_STDARG
#endif /* MI_NO_STDARG */
#endif /* defined(MI_HAS_STDC) */

#ifdef __cplusplus
#define EXTERNC_BEGIN	extern "C" { 
#define EXTERNC_END	}
#else /* __cplusplus */
#define EXTERNC_BEGIN
#define EXTERNC_END
#endif /* __cplusplus */


/*
 * Platform-specific switches
 *  - int/word size
 *  - func calling conventions
 */
#if defined(sparc) || defined(i386) || defined(AIX) /* SPARC switches as well as AIX*/

#define MI_INT_SIZE	32
#define MI_LONG_SIZE	32
#define MI_PTR_SIZE	32

#elif defined(__alpha) || defined(ALPHA_OSF)	/* ALPHA switches */

#ifndef ALPHA_OSF
#define ALPHA_OSF
#endif /* ! ALPHA_OSF */

#define MI_INT_SIZE	32
#define MI_LONG_SIZE	64
#define MI_PTR_SIZE	64

#elif defined(__sgi) || defined(IRIX5)		/* SGI switches */

#ifndef IRIX5
#define IRIX5
#endif /* ! IRIX5 */

#define MI_INT_SIZE	32
#define MI_LONG_SIZE	32
#define MI_PTR_SIZE	32

/* Windows 3.1 Large Model Switches */
#elif defined(MI_WIN31)

#define MI_INT_SIZE	16
#define MI_LONG_SIZE	32
#define MI_PTR_SIZE	32

/* Windows NT Switches */
#elif defined(MI_WINNT)

#define MI_INT_SIZE	32
#define MI_LONG_SIZE	32
#define MI_PTR_SIZE	32

#endif /* defined(machtype) */


#if defined(MI_WIN31)

#define MI_FAR		__far		/* pointer modifier */
#define MI_PASCAL	__pascal	/* pascal calling convention */
#define MI_CDECL	__cdecl		/* C calling convention */
#define MI_EXPORT	__export	/* export function */

/* Windows NT Switches */
#elif defined(MI_WINNT) && !defined(MI_SERVBUILD)

#define MI_FAR		     		/* pointer modifier */
#define MI_PASCAL	__stdcall	/* pascal calling convention */
#define MI_CDECL	__cdecl		/* C calling convention */
#define MI_EXPORT			/* export function */

#else /* !WIN */

#define MI_FAR
#define MI_PASCAL
#define MI_CDECL
#define MI_EXPORT

#endif /* WIN */


/* 
 * For a Windows DLL, all public functions are pascal convention. 
 * Under UNIX, these just expand to nothing. 
 */
#define MI_PROC_EXPORT    MI_FAR MI_PASCAL 		/* public API */
#define MI_PROC_VAEXPORT  MI_FAR MI_CDECL		/* public varargs API.*/
#define MI_PROC_CALLBACK  MI_FAR MI_PASCAL MI_EXPORT	/* callback function */
#define MI_PROC_VACALLBACK MI_FAR MI_CDECL MI_EXPORT	/* callback function */

#endif /* _MICONV_H_ */
